
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.scene.Scene;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

// [r[̃fBA
var media = Media {
     source: "http://gihyo.jp/assets/files/dev/serial/01/javafx/0010/movie.flv"
};

// [r[̃fBA܂񂾃fBAvC
var mediaPlayer = MediaPlayer {
    media: media
    repeatCount: MediaPlayer.REPEAT_FOREVER
};

// fBAvC\m[h
var mediaView = MediaView {
    mediaPlayer: mediaPlayer
}

Stage {
    title: "Animated Movie Player"
    scene: Scene {
        width: 400
        height: 200
        fill: Color.BLACK
        content: mediaView
    }
}

// [r[̍Đ
mediaPlayer.play();

// ̃Aj[V
Timeline {
    autoReverse: true
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0s
            values: mediaView.y => 0
        },
        KeyFrame {
            time: 10s
            // [r[̍ړ͈͂߂
            values: mediaView.y => 200 - media.height
        }
    ]
}.play();

// ̃Aj[V
Timeline {
    autoReverse: true
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0s
            values: mediaView.x => 0
        },
        KeyFrame {
            time: 8s
            // [r[̕ړ͈͂߂
            values: mediaView.x => 400 - media.width
        }
    ]
}.play();
