
import javafx.ext.swing.SwingButton;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.paint.Color;
import javafx.scene.shape.Ellipse;
import javafx.scene.shape.Line;
import javafx.stage.Stage;

// ̌` x W
// TEh̍ẼoXɘA
var locationX = 100.0;

// ̌` y W
// TEh̃{[ɘA
var locationY = 100.0;

var player = MediaPlayer {
    // ẼoX -1.0  1.0 ͈̔
    balance: bind locationX / 100.0 - 1.0

    // {[ 0.0  1.0 ͈̔
    volume: bind (200.0 - locationY) / 200.0

    // ɌJԂ
    repeatCount: MediaPlayer.REPEAT_FOREVER

    // ĐTEht@C
    media: Media {
        source: "{__DIR__}sound.mp3"
    }
}

Stage {
    title: "Sound Controller"
    resizable: false

    scene: Scene {
        width:200
        height: 200

        content: [
            // ľ`
            Group {
                translateX: bind locationX
                translateY: bind locationY

                content: [
                    Ellipse {
                        centerX: 0 centerY: 0
                        rotate: -20 radiusX: 20
                        radiusY: 15
                        fill: Color.BLACK
                    },
                    Line {
                        startX: 18.5 startY: -4.7
                        endX: 18.5 endY: -54.7
                        strokeWidth: 2
                        stroke: Color.BLACK
                    }
                ]

                // hbO̊Jnʒu
                var dragStartX: Number = 0.0;
                var dragStartY: Number = 0.0;

                // }EX{^ꂽATEhĐA
                // ʒuۑ
                onMousePressed: function(event: MouseEvent) {
                    player.play();
                    dragStartX = locationX;
                    dragStartY = locationY;
                }

                // }EX{^痣ꂽATEh̍Đ~
                onMouseReleased: function(event: MouseEvent) {
                    player.stop();
                }

                // hbOꂽAʒuω
                // ʒu̕ύXɉāATEh̃oXA{[ω
                onMouseDragged: function(event: MouseEvent) {
                    // x W̕ύX
                    // EBhE͂ݏoꍇl
                    locationX = event.dragX + dragStartX;
                    if (locationX >= 200) {
                        locationX = 200;
                    } else if (locationX <= 0) {
                        locationX = 0;
                    }

                    // y W̕ύX
                    // EBhE͂ݏoꍇl
                    locationY = event.dragY + dragStartY;
                    if (locationY >= 200) {
                        locationY = 200;
                    } else if (locationY <= 0) {
                        locationY = 0;
                    }
                }
            }
        ]
    }
}